new function(fs, path, contentTypes, error){

this.Server = function(http, url, readFile){
	return class Server {
		constructor(port, dirname){
			var server = http.createServer((incomingMessage, serverResponse) => {
				var fullPath, u = url.parse(incomingMessage.url).pathname, p = path.parse(u);

				if(p.ext === ""){
					u += "/index.html";
					p = path.parse(u);
				}
				
				fullPath = dirname + u;

				serverResponse.setHeader("charset", "utf8");

				fs.stat(
					fullPath,
					(err, stats) => {
						if(err || !stats.isFile()){
							error(serverResponse);
							return;
						}

						readFile(fullPath, p, serverResponse);
					}
				);
			});

			server.listen(
				port,
				(err) => {
					console.log(err || `服务器开启，端口：${port}`);
				}
			);
		};
	};
}(
	require("http"),
	require("url"),
	// readFile
	(fullPath, path, serverResponse) => {
		var contentType = contentTypes[path.ext];

		if(!contentType){
			error(serverResponse);
			return;
		}

		fs.readFile(
			fullPath,
			contentType.encoding,
			(err, content) => {
				if(err){
					error(serverResponse);
					return;
				}

				serverResponse.setHeader("Content-Type", `${contentType.type};charset=utf-8;`);
				serverResponse.writeHead(200);
				serverResponse.write(content);
  				serverResponse.end();
			}
		);
	}
);

module.exports = this.Server;
}(
	require("fs"),
	require("path"),
	// contentTypes
	{
		".txt": {
			type: "text/plain",
			encoding: "utf8"
		},
		".js": {
			type: "text/javascript",
			encoding: "utf8"
		},
		".html": {
			type: "text/html",
			encoding: "utf8"
		},
		".css": {
			type: "text/css",
			encoding: "utf8"
		},
		".json": {
			type: "application/json",
			encoding: "utf8"
		},
		".xml": {
			type: "text/xml",
			encoding: "utf8"
		},
		".md": {
			type: "text/plain",
			encoding: "utf8"
		},
		".png": {
			type: "image/png",
			encoding: null
		},
		".jpg": {
			type: "image/jpeg",
			encoding: null
		},
		".jpeg": {
			type: "image/jpeg",
			encoding: null
		},
		".mp3": {
			type: "audio/mp3",
			encoding: null
		},
		".mp4": {
			type: "video/mp4",
			encoding: null
		}
	},
	// error
	(serverResponse) => {
		serverResponse.setHeader("Content-Type", "text/plain;charset=utf-8;");
		serverResponse.writeHead(404);
		serverResponse.write("找不到指定文件！");
		serverResponse.end();
	}
);